<template>
  <form
    class="pb-20 relative"
    @submit.prevent="generateHandler"
  >
    <div class="flex flex-wrap">
      <div class="md:w-6/12 lg:pr-8 md:pr-4">
        <div class="flex flex-wrap md:sticky md:top-8">
          <h2 class="font-bold mb-1 text-lg w-full dark:text-white">
            Project
          </h2>
          <input-radio
            v-model="form.project"
            :options="formData.projectOptions"
          />
          <h2 class="font-bold mb-1 text-lg w-full dark:text-white mt-4">
            Language
          </h2>
          <input-radio
            v-model="form.language"
            :options="formData.languageOptions"
          />
          <h2 class="font-bold text-lg mb-1 w-full dark:text-white mt-4">
            Spring Boot
          </h2>
          <input-radio
            v-model="form.boot"
            :options="formData.bootOptions"
          />

          <h2 class="font-bold mb-1 text-lg w-full dark:text-white mt-4">
            Project Metadata
          </h2>

          <input-text
            v-model="form.group"
            label="Group"
            class="mt-4"
          />
          <input-text
            v-model="form.artifact"
            label="Atifact"
            class="mt-4"
          />
          <input-text
            v-model="form.name"
            label="Name"
            class="mt-4"
          />
          <input-text
            v-model="form.description"
            label="Description"
            class="mt-4"
          />
          <input-text
            v-model="form.packageName"
            label="Package Name"
            class="mt-4"
          />
          <input-radio
            v-model="form.packaging"
            label="Packaging"
            :options="formData.packagingOptions"
            variant="inline"
            class="mt-4"
          />
          <input-radio
            v-model="form.java"
            label="Java"
            :options="formData.javaOptions"
            variant="inline"
            class="mt-4"
          />
        </div>
      </div>
      <div class="w-full md:w-6/12 md:border-l md:border-gray-400 lg:pl-8 md:pl-4">
        <div class="flex">
          <dependencies-collector
            v-model:selected-items="dependencies"
          />
        </div>
      </div>
    </div>
    <div class="fixed bottom-0 left-0 right-0 py-4 mt-2 bg-gray-200 dark:bg-gray-900 border-t border-gray-400">
      <div class="flex space-x-2 justify-center">
        <app-button class="md:py-3 md:px-6">
          Generate
        </app-button>
      </div>
    </div>
  </form>
</template>

<script>
import InputRadio from '@/components/inputs/InputRadio'
import InputText from '@/components/inputs/InputText'
import DependenciesCollector from '@/components/DependenciesCollector.vue'
export default {
  name: "Home",
  components: {
    InputRadio,
    InputText,
    DependenciesCollector
  },
  data() {
    return {
      form: {
        "project": "Maven Project",
        "language": "Java",
        "boot": "2.4.4",
        "group": "com.example",
        "artifact": "demo",
        "name": "demo",
        "description": "Demo project for Spring Boot",
        "packageName": "com.example.demo",
        "packaging": "Jar",
        "java": "11",
      },
      dependencies: [],
      formData: {
        projectOptions: [
          {
            label: 'Maven Project',
            value: 'Maven Project'
          },
          {
            label: 'Gradle Project',
            value: 'Gradle Project'
          }
        ],
        languageOptions: [
          {
            label: 'Java',
            value: 'Java'
          },
          {
            label: 'Kotlin',
            value: 'Kotlin'
          },
          {
            label: 'Groovy',
            value: 'Groovy'
          }
        ],
        bootOptions: [
          {
            label: '2.5.0 (SNAPSHOT)',
            value: '2.5.0'
          },
          {
            label: '2.5.0 (M3)',
            value: '2.5.0 (M3)'
          },
          {
            label: '2.4.5 (SNAPSHOT)',
            value: '2.4.5 (SNAPSHOT)'
          },
          {
            label: '2.4.4',
            value: '2.4.4'
          },
          {
            label: '2.3.10 (SNAPSHOT)',
            value: '2.3.10 (SNAPSHOT)'
          },
          {
            label: '2.3.9',
            value: '2.3.9'
          },
        ],
        packagingOptions: [
          {
            label: 'Jar',
            value: 'Jar',
          },
          {
            label: 'War',
            value: 'War',
          },
        ],
        javaOptions: [
          {
            label: '16',
            value: '16',
          },
          {
            label: '11',
            value: '11',
          },
          {
            label: '8',
            value: '8',
          },
        ],
      },
    }
  },

  methods: {
    generateHandler() {
      console.log(this.form)
    }
  },
};
</script>
